% Created 2018-11-23 ven. 08:47
\documentclass[a4paper,10pt]{article}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{fixltx2e}
\usepackage{graphicx}
\usepackage{longtable}
\usepackage{float}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{marvosym}
\usepackage{wasysym}
\usepackage{amssymb}
\usepackage{hyperref}
\tolerance=1000
\renewcommand\maketitle{}
\author{Nathalie Furmento}
\date{\today}
\title{notes}
\hypersetup{
  pdfkeywords={},
  pdfsubject={},
  pdfcreator={Emacs 25.2.2 (Org mode 8.2.10)}}
\begin{document}

\maketitle
In Hadoop version 1.0 which is also referred to as MRV1(MapReduce
Version 1), MapReduce performed both processing and resource
management functions. It consisted of a Job Tracker which was the
single master. The Job Tracker allocated the resources, performed
scheduling and monitored the processing jobs. It assigned map and
reduce tasks on a number of subordinate processes called the Task
Trackers. The Task Trackers periodically reported their progress to
the Job Tracker.

This design resulted in scalability bottleneck due to a single Job
Tracker. IBM mentioned in its article that according to Yahoo!, the
practical limits of such a design are reached with a cluster of 5000
nodes and 40,000 tasks running concurrently. Apart from this
limitation, the utilization of computational resources is inefficient
in MRV1. Also, the Hadoop framework became limited only to MapReduce
processing paradigm.


To overcome all these issues, YARN was introduced in Hadoop version
2.0 in the year 2012 by Yahoo and Hortonworks. The basic idea behind
YARN is to relieve MapReduce by taking over the responsibility of
Resource Management and Job Scheduling. YARN started to give Hadoop
the ability to run non-MapReduce jobs within the Hadoop framework.

With the introduction of YARN, the Hadoop ecosystem was completely
revolutionalized. It became much more flexible, efficient and
scalable.

Apart from Resource Management, YARN also performs Job Scheduling.
YARN performs all your processing activities by allocating resources
and scheduling tasks. Apache Hadoop YARN Architecture consists of the
following main components :

\begin{enumerate}
\item Resource Manager: Runs on a master daemon and manages the resource allocation in the cluster.
\item Node Manager: They run on the slave daemons and are responsible for the execution of a task on every single Data Node.
\item Application Master: Manages the user job lifecycle and resource needs of individual applications. It works along with the Node Manager and monitors the execution of tasks.
\item Container: Package of resources including RAM, CPU, Network, HDD etc on a single node.
\end{enumerate}

\pagebreak

\section{Resource Manager}
\label{sec-1}
\begin{itemize}
\item It is the ultimate authority in resource allocation.
\item On receiving the processing requests, it passes parts of requests to corresponding node managers accordingly, where the actual processing takes place.
\item It is the arbitrator of the cluster resources and decides the allocation of the available resources for competing applications.
\item Optimizes the cluster utilization like keeping all resources in use all the time against various constraints such as capacity guarantees, fairness, and SLAs.
\item It has two major components:  a) Scheduler    b) Application Manager
\end{itemize}

\subsection{Scheduler}
\label{sec-1-1}
\begin{itemize}
\item The scheduler is responsible for allocating resources to the various running applications subject to constraints of capacities, queues etc.
\item It is called a pure scheduler in ResourceManager, which means that it does not perform any monitoring or tracking of status for the applications.
\item If there is an application failure or hardware failure, the Scheduler does not guarantee to restart the failed tasks.
\item Performs scheduling based on the resource requirements of the applications.
\item It has a pluggable policy plug-in, which is responsible for partitioning the cluster resources among the various applications. There are two such plug-ins: Capacity Scheduler and Fair Scheduler, which are currently used as Schedulers in ResourceManager.
\end{itemize}

\subsection{Application Manager}
\label{sec-1-2}
\begin{itemize}
\item It is responsible for accepting job submissions.
\item Negotiates the first container from the Resource Manager for executing the application specific Application Master.
\item Manages running the Application Masters in a cluster and provides service for restarting the Application Master container on failure.
\end{itemize}

\section{Node Manager}
\label{sec-2}
\begin{itemize}
\item It takes care of individual nodes in a Hadoop cluster and manages user jobs and workflow on the given node.
\item It registers with the Resource Manager and sends heartbeats with the health status of the node.
\item Its primary goal is to manage application containers assigned to it by the resource manager.
\item It keeps up-to-date with the Resource Manager.
\item Application Master requests the assigned container from the Node Manager by sending it a Container Launch Context(CLC) which includes everything the application needs in order to run. The Node Manager creates the requested container process and starts it.
\item Monitors resource usage (memory, CPU) of individual containers.
\item Performs Log management.
\item It also kills the container as directed by the Resource Manager.
\end{itemize}

\section{Application Master}
\label{sec-3}
\begin{itemize}
\item An application is a single job submitted to the framework. Each such application has a unique Application Master associated with it which is a framework specific entity.
\item It is the process that coordinates an application’s execution in the cluster and also manages faults.
\item Its task is to negotiate resources from the Resource Manager and work with the Node Manager to execute and monitor the component tasks.
\item It is responsible for negotiating appropriate resource containers from the ResourceManager, tracking their status and monitoring progress.
\item Once started, it periodically sends heartbeats to the Resource Manager to affirm its health and to update the record of its resource demands.
\end{itemize}

\section{Container}
\label{sec-4}
\begin{itemize}
\item It is a collection of physical resources such as RAM, CPU cores, and disks on a single node.
\item YARN containers are managed by a container launch context which is container life-cycle(CLC). This record contains a map of environment variables, dependencies stored in a remotely accessible storage, security tokens, payload for Node Manager services and the command necessary to create the process.
\item It grants rights to an application to use a specific amount of resources (memory, CPU etc.) on a specific host.
\end{itemize}
% Emacs 25.2.2 (Org mode 8.2.10)
\end{document}
